class BarcodeInfo {
  const BarcodeInfo({
    required this.ai,
    required this.value,
    this.description,
  });

  final String ai;
  final String value;
  final String? description;

  BarcodeInfo copyWith({
    String? ai,
    String? value,
    String? description,
  }) {
    return BarcodeInfo(
      ai: ai ?? this.ai,
      value: value ?? this.value,
      description: description ?? this.description,
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'ai': ai,
      'value': value,
      'description': description,
    };
  }

  factory BarcodeInfo.fromJson(Map<String, dynamic> json) {
    return BarcodeInfo(
      ai: json['ai'],
      value: json['value'],
      description: json['description'],
    );
  }
}
