class ScanData {
  const ScanData({
    this.errorMessage,
    this.isGS1 = false,
    this.uncategorizedString,
    this.uncategorizedInt,
    this.uncategorizedDouble,
    this.materialNumber,
    this.plant,
    this.storageLocation,
    this.equipmentNumber,
    this.gtin,
    this.batch,
    this.productionDate,
    this.dueDate,
    this.packagingDate,
    this.bestBeforeDate,
    this.expirationDate,
    this.variantNumber,
    this.serialNumber,
    this.additionalProductId,
    this.quantity,
    this.netWeightKg,
    this.netWeightPounds,
    this.lengthMeters,
    this.widthMeters,
    this.depthMeters,
    this.areaSqMeters,
    this.volumeLitres,
    this.volumeCubicMeters,
    this.customersPurchaseOrderNumber,
    this.orderNumber,
    this.orderItemNumber,
    this.inboundDeliveryNumber,
    this.outboundDeliveryNumber,
  });

  final String? errorMessage;
  final bool isGS1;
  final String? uncategorizedString;
  final int? uncategorizedInt;
  final double? uncategorizedDouble;
  final String? materialNumber;
  final String? plant;
  final String? storageLocation;
  final String? equipmentNumber;
  final String? gtin;
  final String? batch;
  final DateTime? productionDate;
  final DateTime? dueDate;
  final DateTime? packagingDate;
  final DateTime? bestBeforeDate;
  final DateTime? expirationDate;
  final String? variantNumber;
  final String? serialNumber;
  final String? additionalProductId;
  final double? quantity;
  final double? netWeightKg;
  final double? netWeightPounds;
  final double? lengthMeters;
  final double? widthMeters;
  final double? depthMeters;
  final double? areaSqMeters;
  final double? volumeLitres;
  final double? volumeCubicMeters;
  final String? customersPurchaseOrderNumber;
  // Old order numbers scan data
  final String? orderNumber;
  final String? orderItemNumber;
  final String? inboundDeliveryNumber;
  final String? outboundDeliveryNumber;

  ScanData copyWith({
    String? errorMessage,
    bool? isGS1,
    String? uncategorizedString,
    int? uncategorizedInt,
    double? uncategorizedDouble,
    String? materialNumber,
    String? plant,
    String? storageLocation,
    String? equipmentNumber,
    String? gtin,
    String? batch,
    DateTime? productionDate,
    DateTime? dueDate,
    DateTime? packagingDate,
    DateTime? bestBeforeDate,
    DateTime? expirationDate,
    String? variantNumber,
    String? serialNumber,
    String? additionalProductId,
    double? quantity,
    double? netWeightKg,
    double? netWeightPounds,
    double? lengthMeters,
    double? widthMeters,
    double? depthMeters,
    double? areaSqMeters,
    double? volumeLitres,
    double? volumeCubicMeters,
    String? customersPurchaseOrderNumber,
    String? orderNumber,
    String? orderItemNumber,
    String? inboundDeliveryNumber,
    String? outboundDeliveryNumber,
  }) {
    return ScanData(
      errorMessage: errorMessage ?? this.errorMessage,
      isGS1: isGS1 ?? this.isGS1,
      uncategorizedString: uncategorizedString ?? this.uncategorizedString,
      uncategorizedInt: uncategorizedInt ?? this.uncategorizedInt,
      uncategorizedDouble: uncategorizedDouble ?? this.uncategorizedDouble,
      materialNumber: materialNumber ?? this.materialNumber,
      plant: plant ?? this.plant,
      storageLocation: storageLocation ?? this.storageLocation,
      equipmentNumber: equipmentNumber ?? this.equipmentNumber,
      gtin: gtin ?? this.gtin,
      batch: batch ?? this.batch,
      productionDate: productionDate ?? this.productionDate,
      dueDate: dueDate ?? this.dueDate,
      packagingDate: packagingDate ?? this.packagingDate,
      bestBeforeDate: bestBeforeDate ?? this.bestBeforeDate,
      expirationDate: expirationDate ?? this.expirationDate,
      variantNumber: variantNumber ?? this.variantNumber,
      serialNumber: serialNumber ?? this.serialNumber,
      additionalProductId: additionalProductId ?? this.additionalProductId,
      quantity: quantity ?? this.quantity,
      netWeightKg: netWeightKg ?? this.netWeightKg,
      netWeightPounds: netWeightPounds ?? this.netWeightPounds,
      lengthMeters: lengthMeters ?? this.lengthMeters,
      widthMeters: widthMeters ?? this.widthMeters,
      depthMeters: depthMeters ?? this.depthMeters,
      areaSqMeters: areaSqMeters ?? this.areaSqMeters,
      volumeLitres: volumeLitres ?? this.volumeLitres,
      volumeCubicMeters: volumeCubicMeters ?? this.volumeCubicMeters,
      customersPurchaseOrderNumber:
          customersPurchaseOrderNumber ?? this.customersPurchaseOrderNumber,
      orderNumber: orderNumber ?? this.orderNumber,
      orderItemNumber: orderItemNumber ?? this.orderItemNumber,
      inboundDeliveryNumber:
          inboundDeliveryNumber ?? this.inboundDeliveryNumber,
      outboundDeliveryNumber:
          outboundDeliveryNumber ?? this.outboundDeliveryNumber,
    );
  }
}
