import 'package:basf_logic_components/extensions/double_extensions.dart';

extension StringExtension on String {
  double? quantityFromString({required String regionString}) {
    if (isEmpty) {
      return null;
    }

    try {
      String toFormat = this;
      List<String> parts;

      if (regionString.contains('de')) {
        parts = replaceAll('.', '').split(',');
      } else {
        parts = replaceAll(',', '').split('.');
      }

      toFormat = parts.length > 1
          ? '${parts.sublist(0, parts.length - 1).join()}.${parts.last}'
          : this;

      return double.tryParse(toFormat);
    } catch (_) {
      return null;
    }
  }

  /// This getter returns a well formatted quantity as String,
  /// if the String can be parsed to double
  /// If the value can't be parsed, it just returns its value
  String convertToQuantity({
    required String regionString,
    bool removeZeroes = false,
    bool replaceComasAndAddDots = false,
  }) {
    return quantityFromString(regionString: regionString)
            ?.getFormattedQuantityString(
          regionString: regionString,
          removeZeros: removeZeroes,
          replaceComasAndAddDots: replaceComasAndAddDots,
        ) ??
        this;
  }
}
