part of 'hardware_scanner_service.dart';

class _BarcodeMapper {
  _BarcodeMapper()
      : _scanInterpreter = ScanInterpreter(),
        _barcodeUtils = BarcodeUtils();

  final ScanInterpreter _scanInterpreter;
  final BarcodeUtils _barcodeUtils;

  BarcodeData getBarcodeData({required String barcode}) {
    try {
      BarcodeData? barcodeData = _scanInterpreter.parseGS1(barcode);

      if (barcodeData != null) {
        return barcodeData;
      }

      if (_barcodeUtils.isProcessOrder(barcode)) {
        return BarcodeData(
          barcodeId: BarcodeId.processOrder,
          code: barcode,
        );
      }

      return BarcodeData(code: barcode);
    } catch (e) {
      if (_barcodeUtils.allBarcodeCharactersAreNumbers(barcode)) {
        return BarcodeData(
          barcodeId: BarcodeId.processOrder,
          code: barcode,
        );
      }
      return BarcodeData(code: barcode);
    }
  }
}
